package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.DataSourceInfo;
import com.izouma.awesomeadmin.service.DataSourceInfoService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/dataSourceInfo")
public class DataSourceInfoController {

    @Autowired
    private DataSourceInfoService dataSourceInfoService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(DataSourceInfo record) {
        List<DataSourceInfo> pp = dataSourceInfoService.getDataSourceInfoList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getDataSourceInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result getDataSourceInfo(@RequestParam(required = false, value = "id") String id) {
        DataSourceInfo data = dataSourceInfoService.getDataSourceInfoById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(DataSourceInfo record) {
        DataSourceInfo data = dataSourceInfoService.getDataSourceInfo(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, DataSourceInfo record) {
        Map<String, Object> result = new HashMap<>();

        List<DataSourceInfo> pp =dataSourceInfoService.getDataSourceInfoByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(DataSourceInfo record) {
        boolean num = dataSourceInfoService.createDataSourceInfo(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateDataSourceInfo(DataSourceInfo record) {
        boolean num = dataSourceInfoService.updateDataSourceInfo(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteDataSourceInfo(@RequestParam(required = true, value = "id") String id) {

        boolean num = dataSourceInfoService.deleteDataSourceInfo(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, DataSourceInfo record) throws Exception {

    List<DataSourceInfo> dataSourceInfos = dataSourceInfoService.getDataSourceInfoList(record);


        String sheetName = "data_source_info";
        String titleName = "数据库配置数据表";
        String fileName = "数据库配置表";
        int columnNumber = 8;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "code" ,   "数据库类型" ,   "链接" ,   "用户名" ,   "密码" ,   "名称"  };
        String[][] dataList = new String[dataSourceInfos.size()][8];

        for (int i = 0; i < dataSourceInfos.size(); i++) {

                        dataList[i][0] = String.valueOf(dataSourceInfos.get(i).getId());
                        dataList[i][1] = String.valueOf(dataSourceInfos.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(dataSourceInfos.get(i).getCode());
                        dataList[i][3] = String.valueOf(dataSourceInfos.get(i).getDatabaseType());
                        dataList[i][4] = String.valueOf(dataSourceInfos.get(i).getUrl());
                        dataList[i][5] = String.valueOf(dataSourceInfos.get(i).getUsername());
                        dataList[i][6] = String.valueOf(dataSourceInfos.get(i).getPassword());
                        dataList[i][7] = String.valueOf(dataSourceInfos.get(i).getDatabaseName());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

